#ifndef GFXCODEC_H
#define GFXCODEC_H

#include <Directory.h>
#include <File.h>
#include "rraster.h"

class GfxCodec 
{
public:
				GfxCodec(BDirectory *, BFile* );
				~GfxCodec();

	virtual	float		CanCreateImage(BFile *);
	virtual GfxImage *	CreateImage(BFile *);
	virtual void		WriteImage(GfxImage*, BFile *);
	
	virtual bool	IsValid();
	virtual	void	Print();
	
		 
	GfxCodec	*next;		// Pointer to next codec so a chain can
							// be created easily.

protected:

	// Informational stuff so that we can identify
	// the add-on and find other parts.
	BDirectory	fBaseDirectory;
	char 		fBaseName[B_FILE_NAME_LENGTH];  
	
	// Function pointers in the identifier module with useful
	// information.
	char	*(*addon_IDName)();
	char	*(*addon_IDAuthor)();
	char	*(*addon_IDNotice)();
	char	*(*addon_IDEncoder)();
	char	*(*addon_IDDecoder)();

	float	(*addon_CanCreate)(void *, long);
	GfxImage	*(*addon_CreateImage)(BFile *);
	long	(*addon_WriteImage)();
	
	image_id	fIdentifier;
	image_id	fDecoder;
	image_id	fEncoder;

private:

};


#endif

