#ifndef RRASTERVIEW_H
#define RRASTERVIEW_H

#include <View.h>

#include "rraster.h"

class BFile;


class	BTSOutlineView : public BView 
{
public:
				BTSOutlineView(BRect, long flags, BRect *inside);
	virtual	void	Draw(BRect);

protected:
		BRect	fInFrame;

private:
};



/*------------------------------------------------------------*/

class	BTSRasterView : public BView 
{
public:
					BTSRasterView(BRect r, long flags, 
						GfxImage *);
virtual				~BTSRasterView();

virtual	void		Draw(BRect);
virtual	void		MouseDown(BPoint where);
virtual	void		MessageReceived(BMessage *msg);

virtual	void		Save();
		void		Save24();
		void		SaveBitmap(BBitmap *an_off);
		void		SaveBitmap24(BBitmap *an_off);

		void		UpdateScrollBars();
		void		paste_bitmap(GfxImage *image, bool sel, char auto_place,
							   BPoint loc);
		void		paste_bitmap(BMessage *msg, bool sel, char auto_place,
							BPoint loc);
		void		paste_bitmap(BFile *a_file, bool sel, char auto_place,
							BPoint loc);
		void		_paste_bitmap(BRect bounds, color_space cs, long length,
							const void *data, bool sel, bool auto_place,
							BPoint loc);
							
		void		DisplayBitmap(GfxImage*);
		void		SetImage();
		void		ClearImage();
		bool		HasSelection();
		void		drag_selection(long h, long v, BPoint mouseDown);
		void		change_selection(long h, long v);
		void		RemoveSelection();
		BFile		*write_bitmap(BMessage *msg, char *fname, BDirectory *the_dir);
		BMessage	*create_clip_message(BBitmap *bm);
		BMessage	*convert_to_ref_message(BMessage *msg);


protected:
		long		LimitHeight(long v);
		long		LimitWidth(long v);
		BRect		sort_rect(BRect *aRect);
		void		clip(long *h, long *v);


		BBitmap		*the_off;
		BView		*off_view;


		uchar		*image;
		BRect		selection;
		char		cur_filename[64];
		BFile		*cur_file;
		GfxImage	*fLastLoaded;
		long		fHeight;
		long		fWidth;

private:

};

#endif
