#include <Application.h>
#include <MenuItem.h>
#include <Menu.h>
#include <MenuBar.h>
#include <ScrollView.h>

#include "rrasterwindow.h"
#include "rrasterview.h"
#include "rrasterapp.h"

#define	OFFSET_H	15
#define	OFFSET_V	15

/*------------------------------------------------------------*/

BRect window_rect(90, 32, 405, 260);


/*------------------------------------------------------------*/

static bool	
IsSmallScreen()
{
	screen_info	info;

	get_screen_info(&info);

	if (info.frame.bottom < 500)
		return(1);
	else
		return(0);
}

/*------------------------------------------------------------*/

#define	INIT_GRAY	0x16

BTSRasterWindow::BTSRasterWindow(char* name, GfxImage *aRaster) 
	: BWindow(window_rect, name, B_TITLED_WINDOW, 0)
{
	BMenu			*a_menu;
	BTSOutlineView		*out_view;
	BRect			aRect;
	BRect			in_rect;
	BScrollView		*scroll_view;
	BMenuBar		*menubar;
	
	long width = aRaster->width;
	long height = aRaster->height;
	printf("BTSRasterWindow:: width: %d  height: %d\n", 
		width, height);
	
	Lock();

	window_rect.OffsetBy(20, 20);

	aRect.Set(0, 0, 1000, 15);
	menubar = new BMenuBar(aRect, "MB");
	menubar->SetBorder(B_BORDER_FRAME);
	
	a_menu = new BMenu("File");
	a_menu->AddItem(new BMenuItem("Save", new BMessage(RAS_SAVE)));
	a_menu->AddItem(new BMenuItem("Save 24 bits", new BMessage(RAS_SAVE24)));
	a_menu->AddItem(new BMenuItem("Open...", new BMessage(RAS_OPEN), 'O'));

	menubar->AddItem(a_menu);
	
	AddChild(menubar);

	float mb_height = menubar->Bounds().Height();

	

	in_rect.Set(0 + OFFSET_H, 0 + OFFSET_V, width - 1 + OFFSET_H, height - 1 + OFFSET_V);
	aRect.Set(0, mb_height + 2, 
		315 - B_V_SCROLL_BAR_WIDTH, 
		228 - B_H_SCROLL_BAR_HEIGHT);
	out_view = new BTSOutlineView(aRect, B_FOLLOW_ALL | B_WILL_DRAW, &in_rect);

	in_rect.Set(0 + OFFSET_H, 0 + OFFSET_V, width - 1 + OFFSET_H, height - 1 + OFFSET_V);
	the_view = new BTSRasterView(in_rect, B_FOLLOW_LEFT + B_FOLLOW_TOP | B_WILL_DRAW, aRaster);
	
	out_view->AddChild(the_view);

	scroll_view = new BScrollView("scroll view", out_view, B_FOLLOW_ALL, 0, TRUE, TRUE, FALSE);

	AddChild(scroll_view);


	if (width > 650)
			width = 650;

	if (height > 490)
			height = 490;

	if (IsSmallScreen())
		ResizeTo(450, 440);
	else
		ResizeTo(45 + width, 45 + mb_height + height);


	the_view->UpdateScrollBars();
	the_view->DisplayBitmap(aRaster);
	
	Unlock();

}

BTSRasterWindow::~BTSRasterWindow()
{
}

/*------------------------------------------------------------*/

bool	
BTSRasterWindow::QuitRequested()
{
	BMessage *msg = new BMessage(RAS_REMOVE_WINDOW);
	
	msg->AddObject("window",this);
	be_app->PostMessage(msg);
	
	return(TRUE);
}

//------------------------------------------------------------
void 
BTSRasterWindow::FrameResized(float, float)
{
	the_view->UpdateScrollBars();
}

/*------------------------------------------------------------*/
 

void	
BTSRasterWindow::MessageReceived(BMessage *msg)
{
	BWindow::MessageReceived(msg);
	BRect r;

	switch(msg->what) 
	{
		case	RAS_SAVE:
				the_view->Save();
		break;
		
		case	RAS_SAVE24:
				the_view->Save24();
		break;
		
		case	RAS_OPEN:
				be_app->RunFilePanel("Open Image", "Open");
		break;
	}

/*
	r.Set(0, 0, 1000, 1000);

	
	switch(msg->what) 
	{
		case	NEW_CB :
				the_view->set_image();
				the_view->Draw(r);
				break;

		case	NEW_TICKNESS :
				tickness = an_event->FindLong("tickness");
				break;
	}
	
*/
}
